Bug 205448

Summary: tools/regression/lib/msun/test-fma fails on i386 (head and stable/10) and on amd64 (only head)
Product: Base System Reporter: Enji Cooper <ngie>
Component: testsAssignee: Enji Cooper <ngie>
Status: Closed FIXED    
Severity: Affects Some People CC: arichardson, das, emaste, gonzo
Priority: ---    
Version: 10.2-STABLE   
Hardware: Any   
OS: Any   

Description Enji Cooper freebsd_committer 2015-12-20 04:24:04 UTC
- Some of the subtests fail on amd64 on head, but not stable/10.
- Some of the subtests fail on i386 on both head and stable/10.

$ cd tools/regression/lib/msun
$ prove -v test-fma.t
test-fma.t .. 
1..19
ok 1 - fma zeroes
ok 2 - fma zeroes
ok 3 - fma zeroes
ok 4 - fma zeroes
Assertion failed: (((void)(fmaf), fetestexcept(((0x04 | 0x20 | 0x01 | 0x08 | 0x10))) == ((0)))), function test_infinities, file test-fma.c, line 126.
Failed 15/19 subtests 

Test Summary Report
-------------------
test-fma.t (Wstat: 134 Tests: 4 Failed: 0)
  Non-zero wait status: 134
  Parse errors: Bad plan.  You planned 19 tests but ran 4.
Files=1, Tests=4,  1 wallclock secs ( 0.02 usr  0.01 sys +  0.23 cusr  0.10 csys =  0.37 CPU)
Result: FAIL
2 files to edit
Comment 1 commit-hook freebsd_committer 2015-12-20 04:32:49 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 20 04:32:30 UTC 2015
New revision: 292493
URL: https://svnweb.freebsd.org/changeset/base/292493

Log:
  Don't run test-fma on i386

  It completely fails all assertions on i386 on both stable/9 and stable/10

  PR: 205448
  MFC after: 1 week
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

Changes:
  head/tools/regression/lib/msun/test-fma.c
Comment 2 commit-hook freebsd_committer 2015-12-20 04:41:51 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 20 04:41:17 UTC 2015
New revision: 292494
URL: https://svnweb.freebsd.org/changeset/base/292494

Log:
  Skip infinities testcases that fail assertions on amd64 only on CURRENT

  PR: 205448
  MFC after: never
  Sponsored by: EMC / Isilon Storage Division

Changes:
  head/tools/regression/lib/msun/test-fma.c
Comment 3 commit-hook freebsd_committer 2015-12-27 11:12:34 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 27 11:12:09 UTC 2015
New revision: 292769
URL: https://svnweb.freebsd.org/changeset/base/292769

Log:
  MFC r292493:

  Don't run test-fma on i386

  It completely fails all assertions on i386 on both stable/9 and stable/10

  PR: 205448
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

Changes:
_U  stable/10/
  stable/10/tools/regression/lib/msun/test-fma.c
Comment 4 commit-hook freebsd_committer 2015-12-27 20:55:36 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 27 20:54:48 UTC 2015
New revision: 292795
URL: https://svnweb.freebsd.org/changeset/base/292795

Log:
  MFC r292491,r292493,r292496:

  r292491:

  Disable test-ctrig.t testcases which fail assertions on i386 [*]

  Also, don't compile the exp2l(3) testcases on platforms that don't support the
  libcall (technically only x86 right now). This makes this test buildable on
  arm*/mips*/powerpc*

  Tested on: stable/10 (amd64/i386), head (amd64/i386)
  PR: 205446 [*]
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

  r292493:

  Don't run test-fma on i386

  It completely fails all assertions on i386 on both stable/9 and stable/10

  PR: 205448
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

  r292496:

  Skip the testcases on i386 (all the assertions fail) [*]

  Also, don't compile the ldexpl(3) testcases on platforms that don't support
  the libcall (technically only x86 right now). This makes this test buildable on
  arm*/mips*/powerpc*

  PR: 205449 [*]
  Tested on: stable/10 (amd64/i386), head (amd64/i386)
  Sponsored by: EMC / Isilon Storage Division

Changes:
_U  stable/10/
  stable/10/tools/regression/lib/msun/test-exponential.c
  stable/10/tools/regression/lib/msun/test-invtrig.c
Comment 5 commit-hook freebsd_committer 2015-12-27 21:34:45 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 27 21:34:37 UTC 2015
New revision: 292802
URL: https://svnweb.freebsd.org/changeset/base/292802

Log:
  MFstable/10 r292795:

  MFC r292491,r292493,r292496:

  r292491:

  Disable test-ctrig.t testcases which fail assertions on i386 [*]

  Also, don't compile the exp2l(3) testcases on platforms that don't support the
  libcall (technically only x86 right now). This makes this test buildable on
  arm*/mips*/powerpc*

  Tested on: stable/10 (amd64/i386), head (amd64/i386)
  PR: 205446 [*]
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

  r292493:

  Don't run test-fma on i386

  It completely fails all assertions on i386 on both stable/9 and stable/10

  PR: 205448
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

  r292496:

  Skip the testcases on i386 (all the assertions fail) [*]

  Also, don't compile the ldexpl(3) testcases on platforms that don't support
  the libcall (technically only x86 right now). This makes this test buildable on
  arm*/mips*/powerpc*

  PR: 205449 [*]
  Tested on: stable/10 (amd64/i386), head (amd64/i386)
  Sponsored by: EMC / Isilon Storage Division

Changes:
_U  stable/9/
_U  stable/9/tools/
_U  stable/9/tools/regression/
  stable/9/tools/regression/lib/msun/test-exponential.c
  stable/9/tools/regression/lib/msun/test-invtrig.c
Comment 6 commit-hook freebsd_committer 2015-12-27 21:53:50 UTC
A commit references this bug:

Author: ngie
Date: Sun Dec 27 21:53:21 UTC 2015
New revision: 292805
URL: https://svnweb.freebsd.org/changeset/base/292805

Log:
  MFstable/10 r292769,r292799:

  r292769:

  MFC r292493:

  Don't run test-fma on i386

  It completely fails all assertions on i386 on both stable/9 and stable/10

  PR: 205448
  X-MFC to: stable/10
  Sponsored by: EMC / Isilon Storage Division

  r292799:

  MFC r292492,r292495,r292647:

  r292492:

  - Use nitems instead of handrolling the macro
  - Use a separate variable for tracking the testcase count instead
    of hardcoding the offset for the testcases

  Sponsored by: EMC / Isilon Storage Division

  r292495:

  Initialize j so it doesn't print out a garbage index

  Use it consistently instead of i in the first loop

  Sponsored by: EMC / Isilon Storage Division

  r292647:

  Use j instead of a hardcoded index (9) and increment it after
  running the NaNs testcases

  Pointyhat to: ngie
  Sponsored by: EMC / Isilon Storage Division

Changes:
_U  stable/9/
_U  stable/9/tools/
_U  stable/9/tools/regression/
  stable/9/tools/regression/lib/msun/test-fma.c
Comment 7 David Schultz freebsd_committer 2016-02-01 09:23:52 UTC
Thanks for cleaning up these tests! Any idea why/when they regressed, though? I wrote these tests on i386 and amd64 machines, so if they are broken, that's a relatively recent development.
Comment 8 Oleksandr Tymoshenko freebsd_committer freebsd_triage 2019-01-21 18:03:52 UTC
There is a commit referencing this PR, but it's still not closed and has been inactive for some time. Closing the PR as fixed but feel free to re-open it if the issue hasn't been completely resolved.

Thanks
Comment 9 Enji Cooper freebsd_committer 2019-01-21 18:28:13 UTC
Test hasn't been fixed. Reopening.
Comment 10 commit-hook freebsd_committer 2021-04-15 15:28:54 UTC
A commit in branch main references this bug:

URL: https://cgit.FreeBSD.org/src/commit/?id=3f01d8c2fe5d31866258c9872f35030d98828e48

commit 3f01d8c2fe5d31866258c9872f35030d98828e48
Author:     Alex Richardson <arichardson@FreeBSD.org>
AuthorDate: 2021-04-15 15:04:19 +0000
Commit:     Alex Richardson <arichardson@FreeBSD.org>
CommitDate: 2021-04-15 15:28:08 +0000

    Remove amd64 XFAIL from tests/lib/msun/fma_test:infinities

    This test no longer fails after 3b00222f156dca5700c839d73e36daf479fa640c.

    PR:             205448
    MFC after:      1 week

 lib/msun/tests/fma_test.c | 4 ----
 1 file changed, 4 deletions(-)
Comment 12 commit-hook freebsd_committer 2021-04-22 11:09:46 UTC
A commit in branch stable/13 references this bug:

URL: https://cgit.FreeBSD.org/src/commit/?id=959cda8efcd2b3f2dfa711b5e27602b0337e718e

commit 959cda8efcd2b3f2dfa711b5e27602b0337e718e
Author:     Alex Richardson <arichardson@FreeBSD.org>
AuthorDate: 2021-04-15 15:04:19 +0000
Commit:     Alex Richardson <arichardson@FreeBSD.org>
CommitDate: 2021-04-22 09:44:54 +0000

    Remove amd64 XFAIL from tests/lib/msun/fma_test:infinities

    This test no longer fails after 3b00222f156dca5700c839d73e36daf479fa640c.

    PR:             205448
    MFC after:      1 week

    (cherry picked from commit 3f01d8c2fe5d31866258c9872f35030d98828e48)

 lib/msun/tests/fma_test.c | 4 ----
 1 file changed, 4 deletions(-)